# Uses of Annotation Interface
java.io.Serial

Packages that use Serial
Package
Description
java.awt
Contains all of the classes for creating user interfaces and for painting graphics and images.
java.awt.color
Provides classes for color spaces.
java.awt.font
Provides classes and interface relating to fonts.
java.security
Provides the classes and interfaces for the security framework.
java.security.cert
Provides classes and interfaces for parsing and managing certificates, certificate revocation lists (CRLs), and certification paths.
java.security.interfaces
Provides interfaces for generating RSA (Rivest, Shamir and Adleman AsymmetricCipher algorithm) keys as defined in the RSA Laboratory Technical Note PKCS#1, and DSA (Digital Signature Algorithm) keys as defined in NIST's FIPS-186.
java.text
Provides classes and interfaces for handling text, dates, numbers, and messages in a manner independent of natural languages.
javax.crypto.interfaces
Provides interfaces for Diffie-Hellman keys as defined in RSA Laboratories' PKCS #3.
javax.print.attribute
Provides classes and interfaces that describe the types of Java Print Service attributes and how they can be collected into attribute sets.

## Uses of Serial in java.awt

Methods in java.awt with annotations of type Serial
Modifier and Type
Method
Description
`protected Object`
AWTKeyStroke.`readResolve()`
Returns a cached instance of `AWTKeyStroke` (or a subclass of `AWTKeyStroke`) which is equal to this instance.

## Uses of Serial in java.awt.color

Methods in java.awt.color with annotations of type Serial
Modifier and Type
Method
Description
`protected Object`
ICC_Profile.`readResolve()`
Resolves instances being deserialized into instances registered with CMM.

## Uses of Serial in java.awt.font

Methods in java.awt.font with annotations of type Serial
Modifier and Type
Method
Description
`protected Object`
TextAttribute.`readResolve()`
Resolves instances being deserialized to the predefined constants.

## Uses of Serial in java.security

Fields in java.security with annotations of type Serial
Modifier and Type
Field
Description
`static final long`
Key.`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.
`static final long`
PrivateKey.`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.
`static final long`
PublicKey.`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.
Methods in java.security with annotations of type Serial
Modifier and Type
Method
Description
`protected Object`
KeyRep.`readResolve()`
Resolve the Key object.

## Uses of Serial in java.security.cert

Methods in java.security.cert with annotations of type Serial
Modifier and Type
Method
Description
`protected Object`
Certificate.CertificateRep.`readResolve()`
Returns a `Certificate` with the type and data of this `CertificateRep`.
`protected Object`
CertPath.CertPathRep.`readResolve()`
Returns a `CertPath` constructed from the type and data of this `CertPathRep`.
`protected Object`
Certificate.`writeReplace()`
Replace the `Certificate` to be serialized with a `CertificateRep` object containing the type and encoded bytes of the `Certificate`.
`protected Object`
CertPath.`writeReplace()`
Replaces the `CertPath` to be serialized with a `CertPathRep` object containing the `Certificate` type and encoded bytes of the `CertPath`.

## Uses of Serial in java.security.interfaces

Fields in java.security.interfaces with annotations of type Serial
Modifier and Type
Field
Description
`static final long`
DSAPrivateKey.`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.
`static final long`
DSAPublicKey.`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.
`static final long`
ECPrivateKey.`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.
`static final long`
ECPublicKey.`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.
`static final long`
RSAMultiPrimePrivateCrtKey.`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.
`static final long`
RSAPrivateCrtKey.`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.
`static final long`
RSAPrivateKey.`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.
`static final long`
RSAPublicKey.`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.

## Uses of Serial in java.text

Methods in java.text with annotations of type Serial
Modifier and Type
Method
Description
`protected Object`
AttributedCharacterIterator.Attribute.`readResolve()`
Resolves instances being deserialized to the predefined constants.
`protected Object`
DateFormat.Field.`readResolve()`
Resolves instances being deserialized to the predefined constants.
`protected Object`
MessageFormat.Field.`readResolve()`
Resolves instances being deserialized to the predefined constants.
`protected Object`
NumberFormat.Field.`readResolve()`
Resolves instances being deserialized to the predefined constants.

## Uses of Serial in javax.crypto.interfaces

Fields in javax.crypto.interfaces with annotations of type Serial
Modifier and Type
Field
Description
`static final long`
DHPrivateKey.`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.
`static final long`
DHPublicKey.`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.
`static final long`
PBEKey.`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.

## Uses of Serial in javax.print.attribute

Methods in javax.print.attribute with annotations of type Serial
Modifier and Type
Method
Description
`protected Object`
EnumSyntax.`readResolve()`
During object input, convert this deserialized enumeration instance to the proper enumeration value defined in the enumeration attribute class.